#import <Foundation/Foundation.h>

@interface DirEntry : NSObject {
    NSURL *_fileURL;
    DirEntry *_parent;
}

+ (NSArray *) entriesAtURL: (NSURL *) url
                withParent: (DirEntry *) parent;

@property (nonatomic, readonly, retain) NSURL *fileURL;
@property (nonatomic, readonly, assign) DirEntry *parent;
@property (nonatomic, readonly, retain) NSArray *children;
@property (nonatomic, readonly, copy) NSString *fullPath;
@property (nonatomic, readonly, copy) NSString *filename;
@property (nonatomic, readonly, assign) unsigned long long filesize;
@property (nonatomic, readonly, assign) BOOL isDirectory;
@property (nonatomic, readonly, assign) BOOL isLeaf;

@end // DirEntry
