// urldirectory.m -- Use URLForDirectory:inDomain:etc

#import <Foundation/Foundation.h>

// gcc -g -Wall -framework Foundation -o urldirectory urldirectory.m

int main (int argc, const char *argv[]) {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    NSURL *appropriateFor = nil;
    if (argc == 2) {
        NSString *path = [NSString stringWithUTF8String: argv[1]];
        appropriateFor = [NSURL fileURLWithPath: path];
    }
    
    NSFileManager *fm = [[[NSFileManager alloc] init] autorelease];

    NSError *error;
    NSURL *directoryURL =
        [fm URLForDirectory: NSItemReplacementDirectory
            inDomain: NSUserDomainMask
            appropriateForURL: appropriateFor
            create: YES
            error: &error];

    if (directoryURL == nil) {
        NSLog (@"Could not get directory URL. Error %@", error);
    } else {
        NSLog (@"directoryURL is %@", directoryURL);
    }

    [pool drain];
    return EXIT_SUCCESS;
} // main

