// MandelOpperAppDelegate.h -- MandelOpper controller class.  It responds to the user,
//                    schedules the operations, and coordinates the underlying
//                    graphics bitmap

#import <Cocoa/Cocoa.h>

@class Bitmap, BitmapView;

@interface MandelOpperAppDelegate : NSObject {
    Bitmap *_bitmap;                   // Where the Mandelbrot set image lives
    IBOutlet BitmapView *_bitmapView;  // Where it gets displayed
    
    IBOutlet NSTextField *_statusLine; // Tell the user what we're doing
    
    NSOperationQueue *_queue;          // Holds the calculation operations
    
    NSRect _region;                    // The region of the set being displayed.
}

@property (assign) IBOutlet BitmapView *bitmapView;
@property (assign) IBOutlet NSTextField *statusLine;

// Start calculating the set and display the results.
- (IBAction) start: (id) sender;
                         
@end // MandelOpperAppDelegate

